drc: fix bugs in armv4 codepath
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 echo "" > $TMPC
28 $CC -E -dD $CFLAGS $TMPC | grep -q $1 || return 1
29 return 0
30}
31
32# setting options to "yes" or "no" will make that choice default,
33# "" means "autodetect".
34
35platform_list="generic pandora maemo caanoo libretro"
36platform="generic"
37builtin_gpu_list="peops unai neon"
38builtin_gpu=""
39sound_driver_list="oss alsa pulseaudio sdl libretro"
40sound_drivers=""
41plugins="plugins/spunull/spunull.so \
42plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
43ram_fixed="no"
44drc_cache_base="no"
45have_armv6=""
46have_armv7=""
47have_arm_neon=""
48have_tslib=""
49have_gles=""
50enable_dynarec="yes"
51need_sdl="no"
52need_libpicofe="yes"
53need_warm="no"
54CFLAGS_GLES=""
55LDLIBS_GLES=""
56# these are for known platforms
57optimize_cortexa8="no"
58optimize_arm926ej="no"
59
60# hardcoded stuff
61CC="${CC-${CROSS_COMPILE}gcc}"
62CXX="${CXX-${CROSS_COMPILE}g++}"
63AS="${AS-${CROSS_COMPILE}as}"
64AR="${AS-${CROSS_COMPILE}ar}"
65MAIN_LDLIBS="$LDLIBS -ldl -lm"
66config_mak="config.mak"
67
68fail()
69{
70 echo "$@"
71 exit 1
72}
73
74# call during arg parsing, so that cmd line can override platform defaults
75set_platform()
76{
77 platform=$1
78 case "$platform" in
79 generic)
80 ;;
81 pandora)
82 sound_drivers="oss alsa"
83 ram_fixed="yes"
84 drc_cache_base="yes"
85 optimize_cortexa8="yes"
86 have_arm_neon="yes"
87 ;;
88 maemo)
89 ram_fixed="yes"
90 drc_cache_base="yes"
91 optimize_cortexa8="yes"
92 have_arm_neon="yes"
93 ;;
94 caanoo)
95 sound_drivers="oss"
96 ram_fixed="yes"
97 drc_cache_base="yes"
98 optimize_arm926ej="yes"
99 need_warm="yes"
100 ;;
101 libretro)
102 sound_drivers="libretro"
103 need_libpicofe="no"
104 ;;
105 *)
106 fail "unsupported platform: $platform"
107 ;;
108 esac
109}
110
111for opt do
112 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
113 case "$opt" in
114 --help|-h) show_help="yes"
115 ;;
116 --platform=*) set_platform "$optarg"
117 ;;
118 --gpu=*) builtin_gpu="$optarg"
119 ;;
120 --sound-drivers=*) sound_drivers="$optarg"
121 ;;
122 --enable-neon) have_arm_neon="yes"
123 ;;
124 --disable-neon) have_arm_neon="no"
125 ;;
126 --disable-dynarec) enable_dynarec="no"
127 ;;
128 *) echo "ERROR: unknown option $opt"; show_help="yes"
129 ;;
130 esac
131done
132
133if [ "$show_help" = "yes" ]; then
134 echo "options:"
135 echo " --help print this message"
136 echo " --platform=NAME target platform [$platform]"
137 echo " available: $platform_list"
138 echo " --gpu=NAME builtin gpu plugin [guessed]"
139 echo " available: $builtin_gpu_list"
140 echo " --sound-drivers=LIST sound output drivers [guessed]"
141 echo " available: $sound_driver_list"
142 echo " --enable-neon"
143 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
144 echo " --disable-dynarec disable dynamic recompiler"
145 echo " (dynarec is only available and enabled on ARM)"
146 echo "influential environment variables:"
147 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
148 exit 1
149fi
150
151# validate selections
152if [ "x$builtin_gpu" != "x" ]; then
153 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
154 fail "unsupported builtin gpu plugin: $builtin_gpu"
155 fi
156fi
157
158if [ "x$sound_drivers" != "x" ]; then
159 for d in $sound_drivers; do
160 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
161 fail "unsupported sound driver: $sound_driver"
162 fi
163 done
164fi
165
166if [ "$need_libpicofe" = "yes" ]; then
167 if ! test -f "frontend/libpicofe/README"; then
168 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
169 fi
170fi
171
172if [ "$need_warm" = "yes" ]; then
173 if ! test -f "frontend/warm/README"; then
174 fail "wARM is missing, please run 'git submodule init && git submodule update'"
175 fi
176fi
177
178if [ -z "$ARCH" ]; then
179 ARCH=`$CC -v 2>&1 | grep -i 'target:' | awk '{print $2}' \
180 | awk -F '-' '{print $1}'`
181fi
182
183# ARM stuff
184if [ "$ARCH" = "arm" ]; then
185 if [ "$optimize_cortexa8" = "yes" ]; then
186 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
187 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
188 fi
189 if [ "$optimize_arm926ej" = "yes" ]; then
190 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
191 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
192 fi
193
194 if [ "x$have_arm_neon" = "x" ]; then
195 # detect NEON from user-supplied cflags to enable asm code
196 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
197 fi
198 if [ "x$have_armv6" = "x" ]; then
199 have_armv6=`check_define __ARM_ARCH_6 && echo yes` || true
200 fi
201 if [ "x$have_armv7" = "x" ]; then
202 if check_define __ARM_ARCH_7A__; then
203 have_armv6="yes"
204 have_armv7="yes"
205 fi
206 fi
207
208 if [ "x$builtin_gpu" = "x" ]; then
209 if [ "$have_arm_neon" = "yes" ]; then
210 builtin_gpu="neon"
211 elif [ "$have_armv7" != "yes" ]; then
212 # pre-ARMv7 hardware is usually not fast enough for peops
213 builtin_gpu="unai"
214 else
215 builtin_gpu="peops"
216 fi
217 fi
218
219 # automatically set mfpu and mfloat-abi if they are not set
220 if [ "$have_arm_neon" = "yes" ]; then
221 fpu="neon"
222 elif [ "$have_armv6" = "yes" ]; then
223 fpu="vfp"
224 fi
225 if [ "x$fpu" != "x" ]; then
226 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
227 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
228 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
229 if [ "$floatabi_set_by_gcc" != "yes" ]; then
230 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
231 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
232 fi
233 fi
234
235 # must disable thumb as recompiler can't handle it
236 if check_define __thumb__; then
237 CFLAGS="$CFLAGS -marm"
238 fi
239else
240 # dynarec only available on ARM
241 enable_dynarec="no"
242fi
243
244if [ "x$builtin_gpu" = "x" ]; then
245 builtin_gpu="peops"
246fi
247
248# supposedly we can avoid -fPIC on armv5 for slightly better performace?
249if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
250 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
251fi
252
253if [ "$ram_fixed" = "yes" ]; then
254 CFLAGS="$CFLAGS -DRAM_FIXED"
255fi
256
257case "$platform" in
258generic)
259 need_sdl="yes"
260 ;;
261maemo)
262 maemo_cflags=`pkg-config --cflags hildon-1`
263 maemo_ldlibs=`pkg-config --libs hildon-1`
264 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES $maemo_cflags"
265 MAIN_LDLIBS="$MAIN_LDLIBS $maemo_ldlibs"
266 ;;
267libretro)
268 CFLAGS="$CFLAGS -fPIC"
269 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
270 ;;
271esac
272
273# header/library presence tests
274check_zlib()
275{
276 cat > $TMPC <<EOF
277 #include <zlib.h>
278 int main(void) { uncompress(0, 0, 0, 0); }
279EOF
280 compile_binary
281}
282
283check_libpng()
284{
285 cat > $TMPC <<EOF
286 #include <png.h>
287 void main() { png_init_io(0, 0); }
288EOF
289 compile_binary
290}
291
292check_oss()
293{
294 cat > $TMPC <<EOF
295 #include <sys/soundcard.h>
296 #include <sys/ioctl.h>
297 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
298EOF
299 compile_binary
300}
301
302check_alsa()
303{
304 cat > $TMPC <<EOF
305 #include <alsa/asoundlib.h>
306 void main() { snd_pcm_open(0, 0, 0, 0); }
307EOF
308 compile_binary "$@"
309}
310
311check_pulseaudio()
312{
313 cat > $TMPC <<EOF
314 #include <pulse/pulseaudio.h>
315 void main() { pa_threaded_mainloop_new(); }
316EOF
317 compile_binary "$@"
318}
319
320check_sdl()
321{
322 cat > $TMPC <<EOF
323 #include <SDL.h>
324 void main() { SDL_OpenAudio(0, 0); }
325EOF
326 compile_binary "$@"
327}
328
329MAIN_LDLIBS="$MAIN_LDLIBS -lz"
330check_zlib || fail "please install zlib (libz-dev)"
331
332MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
333check_libpng || fail "please install libpng (libpng-dev)"
334
335# find what audio support we can compile
336if [ "x$sound_drivers" = "x" ]; then
337 if check_oss; then sound_drivers="$sound_drivers oss"; fi
338 if check_alsa -lasound; then
339 sound_drivers="$sound_drivers alsa"
340 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
341 fi
342 if check_pulseaudio -lpulse; then
343 sound_drivers="$sound_drivers pulseaudio"
344 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
345 fi
346 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
347 sound_drivers="$sound_drivers sdl"
348 need_sdl="yes"
349 fi
350else
351 if echo $sound_drivers | grep -q "\<oss\>"; then
352 check_oss || fail "oss support is missing"
353 fi
354 if echo $sound_drivers | grep -q "\<alsa\>"; then
355 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
356 check_alsa || fail "please install libasound2-dev"
357 fi
358 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
359 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
360 check_pulseaudio || fail "pulseaudio support is missing"
361 fi
362fi
363
364if [ "$need_sdl" = "yes" ]; then
365 which sdl-config > /dev/null || \
366 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
367 CFLAGS="$CFLAGS `sdl-config --cflags`"
368 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
369 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
370fi
371
372# check for tslib (only headers needed)
373if [ "x$have_tslib" = "x" ]; then
374 cat > $TMPC <<EOF
375 #include <tslib.h>
376 void test(struct ts_sample sample) {}
377EOF
378 if compile_object; then
379 have_tslib="yes"
380 else
381 have_tslib="no"
382 fi
383fi
384
385# check for VideoCore stuff for Raspberry Pi
386if [ -d /opt/vc/include -a -d /opt/vc/lib ]; then
387 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads"
388 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
389fi
390
391# check for GLES headers
392cat > $TMPC <<EOF
393#include <GLES/gl.h>
394#include <EGL/egl.h>
395int main(void) {
396 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
397}
398EOF
399if compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
400 have_gles="yes"
401 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
402elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
403 have_gles="yes"
404 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
405fi
406
407if [ "$have_gles" = "yes" ]; then
408 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
409fi
410if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
411 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
412fi
413
414cat > $TMPC <<EOF
415void test(void *f, void *d) { fread(d, 1, 1, f); }
416EOF
417if compile_object -Wno-unused-result; then
418 CFLAGS="$CFLAGS -Wno-unused-result"
419fi
420
421# short plugin list for display
422for p in $plugins; do
423 p1=`basename $p`
424 plugins_short="$p1 $plugins_short"
425done
426
427# set things that failed to autodetect to "no"
428test "x$have_armv6" != "x" || have_armv6="no"
429test "x$have_armv7" != "x" || have_armv7="no"
430test "x$have_arm_neon" != "x" || have_arm_neon="no"
431
432echo "architecture $ARCH"
433echo "platform $platform"
434echo "built-in GPU $builtin_gpu"
435echo "sound drivers $sound_drivers"
436echo "plugins $plugins_short"
437echo "C compiler $CC"
438echo "C compiler flags $CFLAGS"
439echo "libraries $MAIN_LDLIBS"
440echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
441echo "enable dynarec $enable_dynarec"
442echo "ARMv7 optimizations $have_armv7"
443echo "enable ARM NEON $have_arm_neon"
444echo "tslib support $have_tslib"
445if [ "$platform" = "generic" ]; then
446 echo "OpenGL ES output $have_gles"
447fi
448
449echo "# Automatically generated by configure" > $config_mak
450printf "# Configured with:" >> $config_mak
451printf " '%s'" "$0" "$@" >> $config_mak
452echo >> $config_mak
453
454echo "CC = $CC" >> $config_mak
455echo "CXX = $CXX" >> $config_mak
456echo "AS = $AS" >> $config_mak
457echo "CFLAGS += $CFLAGS" >> $config_mak
458echo "ASFLAGS += $ASFLAGS" >> $config_mak
459echo "LDFLAGS += $LDFLAGS" >> $config_mak
460echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
461echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
462echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
463echo >> $config_mak
464
465if [ "$platform" = "libretro" ]; then
466 echo "TARGET = libretro.so" >> $config_mak
467fi
468echo "ARCH = $ARCH" >> $config_mak
469echo "PLATFORM = $platform" >> $config_mak
470echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
471echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
472echo "PLUGINS = $plugins" >> $config_mak
473if [ "$have_arm_neon" = "yes" ]; then
474 echo "HAVE_NEON = 1" >> $config_mak
475fi
476if [ "$have_tslib" = "yes" ]; then
477 echo "HAVE_TSLIB = 1" >> $config_mak
478fi
479if [ "$have_gles" = "yes" ]; then
480 echo "HAVE_GLES = 1" >> $config_mak
481 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
482 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
483fi
484if [ "$enable_dynarec" = "yes" ]; then
485 echo "USE_DYNAREC = 1" >> $config_mak
486fi
487if [ "$drc_cache_base" = "yes" ]; then
488 echo "DRC_CACHE_BASE = 1" >> $config_mak
489fi
490
491# use pandora's skin (for now)
492test -e skin || ln -s frontend/pandora/skin skin
493
494# vim:shiftwidth=2:expandtab